<div class="add-products-space">
  <block-ui message="Loading..."> </block-ui>

  <h3 class="mb-3 mt-3" id="heading">
    {{ addItem ? "Add Product" : "Edit Product" }}
  </h3>

  <app-alert [message]="message" [type]="type" id="alert"> </app-alert>

  <form class="" [formGroup]="productForm">
    <div class="form-group row">
      <div class="col-xl-3 col-lg-6">
        <div class="row">
          <div class="col-xl-12 d-flex align-items-center">
            <app-image-upload></app-image-upload>
          </div>


          <div class="col-xl-12">
            <div class="row ml-0 mr-0 justify-content-between align-items-center">
              <h5>Apply to location</h5>
              <kendo-switch formControlName="isAllowAllLocation" [onLabel]="'All'" [offLabel]="'Selected'" class="mt-3 mb-3 wide-switch" (valueChange)="allLocationChange($event)"></kendo-switch>
            </div>
          </div>

          <!-- Location  -->

          <div class="col-xl-12" *ngIf="productForm.get('isAllowAllLocation').value == false">
            <span>Location*</span>
          </div>

          <div class="col-xl-12 d-flex align-items-center" *ngIf="productForm.get('isAllowAllLocation').value == false">
            <kendo-multiselect [data]="locationList" placeholder="Location Name" formControlName="locationName" style="min-height: 104px" [filterable]="true" [textField]="'locationName'" [valueField]="'id'">
            </kendo-multiselect>
          </div>
        </div>
      </div>
      <div class="col-xl-6 col-lg-6 bg-white">
        <div class="row mt-3 pb-2 pl-3 pr-3">
          <div class="col-xl-12 text-right pl-0 pr-0">
            <span>Required</span>
          </div>

          <!-- Product Code  -->
          <div class="col-xl-12 d-flex align-items-left pl-0 pr-0">
            <mat-form-field [appearance]="apperance" class="full-width">
              <mat-label>Product Code</mat-label>
              <input matInput placeholder="Product Code" required formControlName="productCode" appCharLimit
                     [frmGroup]="productForm" fcName="productCode" [max]="10">

              <mat-error *ngIf="productForm.get('productCode').hasError('exceedLimit')">
                {{productForm.get('productCode').getError('exceedLimit')}}
              </mat-error>

              <mat-error *ngIf="productForm.get('productCode').hasError('required')">
                This field is required
              </mat-error>
            </mat-form-field>
          </div>

          <!-- Medicare Code  -->
          <div class="col-xl-12 align-items-right pl-0 pr-0">
            <mat-form-field [appearance]="apperance" class="full-width">
              <mat-label>Medicare Code</mat-label>
              <input matInput placeholder="Medicare Code" formControlName="medicareCode"  appCharLimit appNoSpecChar
                     [frmGroup]="productForm" fcName="medicareCode" [max]="5">

              <mat-error *ngIf="productForm.get('medicareCode').hasError('exceedLimit')">
                {{productForm.get('medicareCode').getError('exceedLimit')}}
              </mat-error>

              <mat-error *ngIf="productForm.get('medicareCode').hasError('notZero')">
                This field should not be zero.
              </mat-error>
            </mat-form-field>
          </div>

          <!-- DVA Code  -->
          <div class="col-xl-12 align-items-right pl-0 pr-0">
            <mat-form-field [appearance]="apperance" class="full-width">
              <mat-label>DVA Code</mat-label>
              <input matInput placeholder="DVA Code" formControlName="dvaCode" appCharLimit appNoSpecChar
                     [frmGroup]="productForm" fcName="dvaCode" [max]="5">

              <mat-error *ngIf="productForm.get('dvaCode').hasError('exceedLimit')">
                {{productForm.get('dvaCode').getError('exceedLimit')}}
              </mat-error>

              <mat-error *ngIf="productForm.get('dvaCode').hasError('notZero')">
                This field should not be zero.
              </mat-error>
            </mat-form-field>
          </div>

          <div class="col-xl-12 pl-0 pr-0">
            <mat-divider></mat-divider>
          </div>

          <div class="col-xl-12 text-right pt-2 pl-0 pr-0">
            <span>Required</span>
          </div>

          <!-- Product Name  -->
          <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
            <mat-form-field [appearance]="apperance" class="full-width">
              <mat-label>Product Name*</mat-label>
              <input matInput placeholder="Product Name" formControlName="productName" appCharLimit
                     [frmGroup]="productForm" fcName="productName" [max]="100">

              <mat-error *ngIf="productForm.get('productName').hasError('exceedLimit')">
                {{productForm.get('productName').getError('exceedLimit')}}
              </mat-error>

              <mat-error *ngIf="productForm.get('productName').hasError('required')">
                This field is required
              </mat-error>
            </mat-form-field>
          </div>

          <!-- Description  -->
          <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
            <mat-form-field [appearance]="apperance" class="full-width">
              <textarea matInput placeholder="Description" formControlName="description" rows="3" appCharLimit
                        [frmGroup]="productForm" fcName="description" [max]="200"></textarea>

              <mat-error *ngIf="productForm.get('description').hasError('exceedLimit')">
                {{productForm.get('description').getError('exceedLimit')}}
              </mat-error>
            </mat-form-field>
          </div>

          <!-- Category -->
          <div class="col-xl-12 d-block align-items-center kendo-dropdown-bottom pl-0 pr-0">
            <mat-form-field [appearance]="apperance" class="full-width">
              <mat-label>Category*</mat-label>
              <app-add-new-dropdown [categoryId]="productCategoryParentId" formControlName="productCategory"></app-add-new-dropdown>


               <mat-error *ngIf="productForm.get('productCategory').hasError('required')">
                This field is required
              </mat-error>

            </mat-form-field>
          </div>

          <!-- Supplier name  -->
          <div class="col-xl-12 pl-0 pr-0">
            <span>Supplier Name</span>
          </div>
          <div class="col-xl-12 d-flex pb-3 pl-0 pr-0">
            <kendo-dropdownlist [data]="suppliers" [valuePrimitive]="true" [formControl]="productForm.get('supplierId')" [textField]="'name'" [valueField]="'id'" formControlName="supplierId" class="kendo-dropdown-size w-100">
            </kendo-dropdownlist>
            <button mat-stroked-button color="accent" class="plus-button" (click)="openSlider()">+</button>
          </div>

          <!-- Serial Number  -->
          <div class="col-xl-12 d-flex align-items-center pl-0 pr-0">
            <mat-form-field [appearance]="apperance" class="full-width">
              <input matInput placeholder="Serial Number" formControlName="serialNumber" />
              <mat-hint>Serial number on the package.</mat-hint>
            </mat-form-field>
          </div>
        </div>
      </div>
      <div class="col-xl-3 col-lg-12">
        <div class="col-xl-12 text-right">
          <kendo-switch formControlName="status" [onLabel]="'Active'" [offLabel]="'Inactive'" class="wider-switch">
          </kendo-switch>
        </div>
        <br />
        <div class="col-xl-12">
          <mat-divider></mat-divider>
          <h4 class="mt-3 mb-3 bold d-flex align-items-center d-inline-block">
            <mat-icon>shopping_basket</mat-icon>
            Units and Pricing
          </h4>
        </div>

        <!-- Unit Of Measurement  -->
        <div class="col-xl-12 d-block align-items-center">
          <mat-form-field [appearance]="apperance" class="full-width">
            <mat-label>Unit Of Measurement</mat-label>
            <app-add-new-dropdown [categoryId]="unitOfMeasurementParentId" [selectedId]="unitOfMeasurement" (appId)="appIdUnitOfMeasurementChangedHandler($event)"></app-add-new-dropdown>
          </mat-form-field>
        </div>

        <!-- AWC Mascot -->
        <div class="col-xl-12 text-right">
          <span>Required</span>
        </div>
        <div class="col-xl-12 d-flex align-items-center">
          <mat-form-field [appearance]="apperance" class="full-width">
            <mat-label>Current Stock *</mat-label>
            <input matInput placeholder="Current Stock" formControlName="currentStock" type="number" appOnlyNumber
            appCharLimit [frmGroup]="productForm" fcName="currentStock" [max]="5"
            />


            <mat-error *ngIf="productForm.get('currentStock').hasError('exceedLimit')">
              {{productForm.get('currentStock').getError('exceedLimit')}}
            </mat-error>

            <mat-error *ngIf="productForm.get('currentStock').hasError('required')">
              This field is required
            </mat-error>
          </mat-form-field>
          <!-- <div class="col-xl-12 text-right pt-2 pl-0 pr-0">
            <span>Required</span>
          </div> -->

        </div>

        <!-- Minimum Stock  -->
        <div class="col-xl-12 d-flex align-items-center">
          <mat-form-field [appearance]="apperance" class="full-width">
            <mat-label>Minimum Stock</mat-label>
            <input matInput placeholder="Minimum Stock" formControlName="minimumStock" type="number" appOnlyNumber
            appCharLimit [frmGroup]="productForm" fcName="minimumStock" [max]="5" />

            <mat-error *ngIf="productForm.get('minimumStock').hasError('exceedLimit')">
              {{productForm.get('minimumStock').getError('exceedLimit')}}
            </mat-error>
          </mat-form-field>
        </div>

        <!-- Cost Price  -->
        <div class="col-xl-12 d-flex align-items-center">
          <mat-form-field [appearance]="apperance" class="full-width">
            <mat-label>Cost Price (AUD)</mat-label>
            <input matInput formControlName="costPrice" type="number" appOnlyNumber />
          </mat-form-field>
        </div>

        <!-- Sale Price  -->
        <div class="col-xl-12 text-right">
          <span>Required</span>
        </div>
        <div class="col-xl-12 d-flex align-items-center">
          <mat-form-field [appearance]="apperance" class="full-width">
            <mat-label>Sales Price (AUD) *</mat-label>
            <input matInput placeholder="Sale Price" type="number" formControlName="salePrice" appOnlyNumber
             [frmGroup]="productForm" fcName="salePrice" appCharLimit />

            <mat-error *ngIf="productForm.get('salePrice').hasError('required')">
              This field is required
            </mat-error>
          </mat-form-field>
        </div>

        <!-- Tax Type  -->
        <div class="col-xl-12">
          <span>Tax Type*</span>
        </div>
        <div class="col-xl-12 d-flex align-items-center kendo-dropdown-bottom">
          <kendo-dropdownlist [data]="taxTypes" [valuePrimitive]="true" [textField]="'taxType'" [valueField]="'id'" formControlName="taxTypeId" [formControl]="productForm.get('taxTypeId')" (valueChange)="handleTaxTypeChange($event)" class="mat-form-field-infix cat-height"
          >
          </kendo-dropdownlist>


        </div>

        <!-- Tax Option  -->
        <div *ngIf="taxOptionHide" class="col-xl-12 d-flex align-items-center radio-margin">
          Tax Option
        </div>
        <div *ngIf="taxOptionHide" class="col-xl-12 d-flex align-items-center">
          <mat-radio-group formControlName="taxOptionId">

            <mat-radio-button class="radio-margin" value="1" [checked]="taxOptionSelected === 1">Inclusive</mat-radio-button>
            <mat-radio-button class="radio-margin" value="2" [checked]="taxOptionSelected === 2">Exclusive</mat-radio-button>
          </mat-radio-group>
        </div>
      </div>
    </div>
  </form>

  <div class="text-right products-control-row">
    <mat-divider class=""></mat-divider>
    <div class="pt-3">
      <button mat-stroked-button color="accent" class="mr-2" (click)="cancel()">Cancel</button>
      <button mat-raised-button color="accent" class="mr-3 wide footer-btn-customize"
              (click)="createProduct()"
              *appAccess="moduleName; lookFor: ['C', 'E']"
              [disabled]="productForm.invalid">
        <div *ngIf="!submitting">Save</div>
        <div *ngIf="submitting">Saving...</div>
      </button>
    </div>
  </div>
</div>
<div id="sliderShadow" class="overlay-shadow">
  <div id="slider" class="overlay">
    <div class="overlay-header">
      <div class="row">
        <span class="overlay-title">Add Supplier</span>
        <a href="javascript:void(0)" class="closebtn" (click)="closeSlider()">
          <span class="material-icons md-36"> clear </span>
        </a>
      </div>
    </div>
    <div class="overlay-content">
      <app-add-general-contacts [contact]="contact" generalType="Supplier" (parentProductCallBack)="parentProductCallBack($event)"></app-add-general-contacts>
    </div>
  </div>
</div>
